---
title: TreeWalker.firstChild()
slug: Web/API/TreeWalker/firstChild
tags:
  - API
  - DOM
  - DOM Reference
  - Method
  - TreeWalker
---
<p>{{ APIRef("DOM") }}</p>

<p>The <strong><code>TreeWalker.firstChild()</code></strong> method moves the current {{domxref("Node")}} to the first <em>visible</em> child of the current node, and returns the found child. It also moves the current node to this child. If no such child exists, returns <code>null</code> and the current node is not changed.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>node</em> = <em>treeWalker</em>.firstChild;</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js">var treeWalker = document.createTreeWalker(
    document.body,
    NodeFilter.SHOW_ELEMENT,
    { acceptNode: function(node) { return NodeFilter.FILTER_ACCEPT; } },
    false
);
var node = treeWalker.firstChild(); // returns the first child of the root element, or null if none

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-treewalker-firstchild', 'TreeWalker.firstChild')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change from {{SpecName('DOM2 Traversal_Range')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'traversal.html#Traversal-TreeWalker-firstChild', 'TreeWalker.firstChild')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.TreeWalker.firstChild")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("TreeWalker")}} interface it belongs to.</li>
</ul>
